unit LD48Path;

interface

Uses
  SysUtils,Classes;

Var
  Map : Array[0..99,0..99] of Integer;
  Access : Array[0..99,0..99] of Integer;
  SL : TStringList;

Procedure InitMap;
Function BestDir(FromX,FromY,ToX,ToY : Integer) : Integer;

implementation

Const
TileDirs : Array[0..11,1..4] of Boolean =
  ((False,False,True,True),
   (True,True,True,True),
   (True,True,False,True),
   (False,True,True,False),
   (True,True,False,False),
   (True,True,True,False),
   (False,True,True,True),
   (True,False,True,True),
   (True,False,True,False),
   (False,True,False,True),
   (True,False,False,True),
   (True,True,True,True));


Procedure InitMap;
Var
  I,J : Integer;
Begin
  For I := 0 to 99 do
    For J := 0 to 99 do
      Begin
        Map[I,J] := -1;
        Access[I,J] := 0;
      End;
End;
Const
  Dir : Array[1..4] of Record X,Y : Integer; End =
    ((X:0;Y:-1),(X:0;Y:1),(X:-1;Y:0),(X:1;Y:0));
Function BestDir(FromX,FromY,ToX,ToY : Integer) : Integer;
Var
  Found : Boolean;
  BestDirToGo : Integer;
  Procedure NextSearch(W,X,Y,D : Integer);
  Begin
    If (X = FromX) and (Y = FromY) then
      Begin
        Found := True;
        Access[X,Y] := W;
        BestDirToGo := D;
      End
    Else
      Begin
        If Access[X,Y] < 1 then
          Begin
            SL.Add(FormatFloat('0000000',W)+':'+IntToStr(X)+','+IntToStr(Y));
            Access[X,Y] := W;
          End;
      End;
  End;
  Procedure DoSearch;
  Var
    W,X,Y : Integer;
    S : String;
  Begin
    If SL.Count > 0 then
      Begin
        S := SL[0];
        SL.Delete(0);
        W := StrToInt(Copy(S,1,Pos(':',S)-1));
        S := Copy(S,Pos(':',S)+1,Length(S));
        X := StrToInt(Copy(S,1,Pos(',',S)-1));
        S := Copy(S,Pos(',',S)+1,Length(S));
        Y := StrToInt(S);
        If TileDirs[Map[X,Y],1] and (Not Found) then
          NextSearch(W+10,X,Y-1,1);
        If TileDirs[Map[X,Y],2] and (Not Found) then
          NextSearch(W+10,X,Y+1,2);
        If TileDirs[Map[X,Y],3] and (Not Found) then
          NextSearch(W+10,X-1,Y,3);
        If TileDirs[Map[X,Y],4] and (Not Found) then
          NextSearch(W+10,X+1,Y,4);
      End
    Else
      Begin
        Found := True;
        BestDirToGo := 0;
      End;
  End;
Begin
Try
  Found := False;
  If SL = Nil then
    Begin
      SL := TStringList.Create;
      SL.Sorted := True;
    End;
  SL.Clear;
//  Access[FromX,FromY] := 1;
  NextSearch(1,ToX,ToY,0);
  While Not Found do
    DoSearch;

  SL.Free; SL := Nil;
  Case BestDirToGo of
  1: Result := 2;
  2: Result := 1;
  3: Result := 4;
  4: Result := 3;
  End;
Except
  On Exception do
    Result := 0;
End;
End;

end.
