program TreasureHunter;

//  Simple 2D Library - Game Template Version 1.04
//     Ver 1.04 - Convert to class to manage program instead of
//                sequential programming
//              - Changed Scene to GameState
//              - Changed to 24bit screen  
//
//  Requires: FreePascal, or Delphi
//            JEDI-SDL
//  Platform: Windows
//            will work on any other platform that supports FreePascal and SDL
//                 with a small amount of work
//
//  This file is part of the Free Pascal Simple 2D Libraries
//    Copyright (c) 2004 by William Cairns (CairnsGames S.A.) and
//                         the Delphi Game Development (DGDev) Site
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//       (I got this from the JEDI-SDL files and it sounds Cool!)
//
// By using this work you have immediatly agreed with the above.
//
// The work can be used for any purpose. You may sell it, use it in a game
// delete it or change it as you wish with no reward to the original
// developers.
//
// We do however ask that if this work is used that some mention of it be made
// on the DGDev or PGDev web sites.
//
// USAGE:
//   This is the initial template for creating a game. It sets up the required
//   SDL window and an example image.
//   You need to add all the required game logic.

uses
  Classes,
  Graphics,
  SysUtils,
  S2DLDraws,
  S2DLLogger,
  LD48GameUnit in 'LD48GameUnit.pas',
  LD48MonsterUnit in 'LD48MonsterUnit.pas',
  LD48Path in 'LD48Path.pas';

const
  VERSION_NO = '1.00';
  TITLE = 'Treasure Hunter';
  AUTHOR = 'William Cairns';


Begin
  Game := TS2DLGame.Create;
  S2DLDraw.WindowCaption(TITLE+' v' + VERSION_NO + ' by '+AUTHOR);
  Log.LogStatus(TITLE+' v' + VERSION_NO + ' by '+AUTHOR, 'Initialize');
  Game.Run;
  Game.Free;
End.


